<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<ui:composition xmlns:ui="http://java.sun.com/jsf/facelets" xmlns:h="http://java.sun.com/jsf/html"
                xmlns:gdk="http://www.ihe.net/gazellecdk" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:f="http://java.sun.com/jsf/core" xmlns:rich="http://richfaces.org/rich"
                xmlns:a4j="http://richfaces.org/a4j" xmlns:g="http://www.ihe.net/gazelle"
                xmlns="http://www.w3.org/1999/xhtml" template="//layout/template.xhtml">
    <ui:define name="body">
        <h:form id="globalform">
            <script type="text/javascript" src="https://www.google.com/jsapi"/>
            <script type="text/javascript">
                google.load("visualization", "1", {packages:["corechart"]});
                google.setOnLoadCallback(drawAllCharts);

                function drawAllCharts()
                {
                    drawPieChart();
                    drawBarChartForIPs();
                    drawTimeLineYear();
                    drawTimeLineMonth();
                    drawColumnChart();
                }

                function drawColumnChart() {
                    var data = google.visualization.arrayToDataTable([
                        ['Profile OID', 'Validations requests']
                        <ui:repeat value="#{statisticsManager.getResultsPerProfiles()}" var="stat">
                            ,['#{stat[0]}',  #{stat[1]}]
                    </ui:repeat>
                ]);

                    var options = {
                        hAxis: {title: 'Profile OID',
                            textStyle: {fontSize:9},
                            slantedText: true,
                            slantedTextAngle: 45,
                            allowContainerBoundaryTextCufoff: false},
                        vAxis: {title: 'Number of validation requests',
                            logScale: true}
                    };

                    var chart = new google.visualization.ColumnChart(document.getElementById('columnDiv'));
                    chart.draw(data, options);
                    google.visualization.events.addListener(chart, 'select', selectProfileHandler);
                    //var minichart = new google.visualization.ColumnChart(document.getElementById('minibarDiv'));
                    //minichart.draw(data,options);

                    // display the profile informationi when clicking on a column of the graphic
                    function selectProfileHandler(){
                        var row = chart.getSelection()[0].row;
                        var profileUrl = '#{applicationConfiguration.getApplicationUrl()}/browser/profile.seam?oid=' + data.getValue(row, 0);
                        open(profileUrl, '_blank');
                    }
                }


                function drawBarChartForIPs() {
                    var data = google.visualization.arrayToDataTable([
                        ['Caller IP', 'Validation requests']
                        <ui:repeat value="#{statisticsManager.getStatisticsPerCallerIp()}" var="stat">
                            ,['#{stat[0]}',  #{stat[1]}]
                    </ui:repeat>
                ]);

                    var options = {
                        hAxis: {title: 'IP',
                            textStyle: {fontSize:9},
                            slantedText: true,
                            slantedTextAngle: 45},
                        vAxis: {title: 'Number of validation requests',
                            logScale:true}
                    };

                    var chart = new google.visualization.ColumnChart(document.getElementById('callerIpDiv'));
                    chart.draw(data, options);
                    google.visualization.events.addListener(chart, 'select', selectIPHandler);

                    function selectIPHandler(){
                        var row = chart.getSelection()[0].row;
                        var geoipURL = 'http://www.geoiptool.com/en/?IP=' + data.getValue(row, 0);
                        open(geoipURL, '_blank');
                    }
                    //var minichart = new google.visualization.ColumnChart(document.getElementById('miniCallerIpDiv'));
                    //minichart.draw(data, options);
                }

                function drawPieChart() {
                    var data = google.visualization.arrayToDataTable([
                        ['Status', 'percentage']
                        <ui:repeat value="#{statisticsManager.getStatisticsPerResultStatus()}" var="stat">
                            ,['#{stat[0]}',  #{stat[1]}]
                    </ui:repeat>
                ]);

                    var options = {
                        slices: {0: {color: 'grey'}, 1: {color: 'red'}, 2: {color: 'orange'}, 3: {color: 'green'}}
                    };

                    var chart = new google.visualization.PieChart(document.getElementById('repartitionDiv'));
                    chart.draw(data, options);
                    //var minichart = new google.visualization.PieChart(document.getElementById('miniRepartitionDiv'));
                    //minichart.draw(data, options);
                }

                function drawTimeLineYear(){
                    var data = google.visualization.arrayToDataTable([
                        ['Period', 'Number of validations']
                        <ui:repeat value="#{statisticsManager.getStatisticsPerDate(1)}" var="stat">
                            ,['#{stat[0]}',  #{stat[1]}]
                    </ui:repeat>
                ]);

                    var options = {
                        hAxis: {title: 'Period of time (years)', textStyle: {fontSize:9}},
                        vAxis: {title: 'Number of validation requests'},
                        pointSize: 3
                    };
                    var chartYear = new google.visualization.LineChart(document.getElementById('timeline_year'));
                    chartYear.draw(data, options);
                }

                function drawTimeLineMonth(){
                    var data = google.visualization.arrayToDataTable([
                        ['Period', 'Number of validations']
                        <ui:repeat value="#{statisticsManager.getStatisticsPerDate(2)}" var="stat">
                            ,['#{stat[0]}',  #{stat[1]}]
                    </ui:repeat>
                ]);

                    var options = {
                        hAxis: {title: 'Period of time (months)', textStyle: {fontSize:9}},
                        vAxis: {title: 'Number of validation requests'},
                        pointSize: 3
                    };
                    var chartYear = new google.visualization.LineChart(document.getElementById('timeline_month'));
                    chartYear.draw(data, options);
                }
            </script>


            <s:div id="globalDiv">
                <h1>Statitstics HL7v2</h1>
                <ui:decorate template="/layout/panels/_panel_title.xhtml">
                    <ui:define name="panel_title">
                        #{messages['gazelle.hl7.validator.StatisticsCriteria']}
                    </ui:define>
                    <ui:decorate template="/layout/panels/_panel_title.xhtml">
                        <ui:define name="panel_title">
                            #{messages['gazelle.hl7.validator.Period']}
                        </ui:define>
                        <div class="row">
                            <div class="col-lg-3">
                                 <s:decorate template="/layout/form/_edit.xhtml">
                                    <ui:define name="label">#{messages['gazelle.hl7.validator.From']}</ui:define>
                                    <a4j:outputPanel id="fromdate" layout="block">
                                        <rich:calendar value="#{statisticsManager.startDate}"
                                                       locale="#{localeSelector.localeString}" datePattern="yyyy/MM/dd"
                                                       showApplyButton="false">
                                        </rich:calendar>
                                    </a4j:outputPanel>
                                 </s:decorate>
                            </div>
                            <div class="col-lg-3">
                                <s:decorate template="/layout/form/_edit.xhtml">
                                        <ui:define name="label">#{messages['gazelle.hl7.validator.To']}</ui:define>
                                        <a4j:outputPanel id="todate" layout="block">
                                            <rich:calendar value="#{statisticsManager.endDate}"
                                                           locale="#{localeSelector.localeString}" datePattern="yyyy/MM/dd"
                                                           showApplyButton="false">
                                            </rich:calendar>
                                        </a4j:outputPanel>
                                    </s:decorate>
                            </div>
                        </div>
                    </ui:decorate>
                    <s:div id="IPSelectionPanel">
                        <ui:decorate template="/layout/panels/_panel_title.xhtml">
                            <ui:define name="panel_title">
                                #{messages['gazelle.hl7.validator.IncludeExcludeIPRange']}
                            </ui:define>
                            <s:decorate template="/layout/form/_edit.xhtml">
                                <h:selectOneRadio value="#{statisticsManager.ipFilter}" layout="pageDirection">
                                    <f:selectItem itemLabel="#{messages['gazelle.hl7.validator.NoFilter']}"
                                                  itemValue="#{statisticsManager.ALL}"/>
                                    <f:selectItem itemLabel="#{messages['gazelle.hl7.validator.IncludeIPStartingWith']}"
                                                  itemValue="#{statisticsManager.INCLUDE}"/>
                                    <f:selectItem itemLabel="#{messages['gazelle.hl7.validator.ExcludeIPStartingWith']}"
                                                  itemValue="#{statisticsManager.EXCLUDE}"/>
                                    <a4j:ajax event="change" render="IPSelectionPanel"/>
                                </h:selectOneRadio>
                            </s:decorate>
                            <s:decorate template="/layout/form/_edit.xhtml">
                                <ui:param name="id" value="ipStartsWithId"/>
                                <ui:define name="label">
                                    IP Starts with
                                </ui:define>
                                <h:inputText id="ipStartsWithId" value="#{statisticsManager.ipStartsWith}"
                                             rendered="#{not statisticsManager.ipFilter.equals(statisticsManager.ALL)}"
                                             styleClass="form-control"/>
                            </s:decorate>
                        </ui:decorate>
                    </s:div>
                    <ui:decorate template="/layout/panels/_panel_title.xhtml">
                        <ui:define name="panel_title">
                            #{messages['gazelle.hl7.validator.OtherOptions']}
                        </ui:define>
                        <s:div id="criteriaOnProfiles">
                            <s:decorate template="/layout/form/_edit.xhtml">
                                <ui:define name="label">#{messages['gazelle.hl7.validator.SelectAllProfiles']}</ui:define>
                                <h:selectBooleanCheckbox value="#{statisticsManager.allProfiles}">
                                    <a4j:ajax event="change" render="criteriaOnProfiles"/>
                                </h:selectBooleanCheckbox>
                            </s:decorate>
                            <s:decorate template="/layout/form/_edit.xhtml" rendered="#{not statisticsManager.allProfiles}">
                                <ui:define name="label">#{messages['gazelle.hl7.validator.OnlyProfileWithOID']}</ui:define>
                                <h:inputText value="#{statisticsManager.profileOID}" styleClass="form-control"/>
                            </s:decorate>
                            <h:outputText
                                    value="#{messages['gazelle.hl7.validator.GMMIsNotReachableCannotProvideASubsetOfProfiles']}"
                                    rendered="#{not statisticsManager.allProfiles and statisticsManager.params == null}"/>
                            <s:div rendered="#{not statisticsManager.allProfiles and statisticsManager.params != null}">
                                <h3>#{messages['gazelle.hl7.validator.GetProfilesForFollowingCriteria']}</h3>
                                <div class="form-inline">
                                    <ui:decorate template="/layout/form/_edit.xhtml">
                                        <ui:param name="id" value="domainKeywordId"/>
                                        <ui:define name="label">#{messages['gazelle.hl7.validator.DomainKeyword']}
                                        </ui:define>
                                        <h:inputText id="domainKeywordId" value="#{statisticsManager.params.domainKeyword}" styleClass="form-control labelOnTopForm"/>
                                    </ui:decorate>
                                    <ui:decorate template="/layout/form/_edit.xhtml">
                                        <ui:param name="id" value="actorKeywordId"/>
                                        <ui:define name="label">#{messages['gazelle.hl7.validator.ActorKeyword']}
                                        </ui:define>
                                        <h:inputText id="actorKeywordId" value="#{statisticsManager.params.actorKeyword}" styleClass="form-control labelOnTopForm"/>
                                    </ui:decorate>
                                    <ui:decorate template="/layout/form/_edit.xhtml">
                                        <ui:param name="id" value="transactionKeywordId"/>
                                        <ui:define name="label">#{messages['gazelle.hl7.validator.TransactionKeyword']}
                                        </ui:define>
                                        <h:inputText id="transactionKeywordId" value="#{statisticsManager.params.transactionKeyword}" styleClass="form-control labelOnTopForm"/>
                                    </ui:decorate>
                                    <ui:decorate template="/layout/form/_edit.xhtml">
                                        <ui:param name="id" value="messageTypeId"/>
                                        <ui:define name="label">#{messages['gazelle.hl7.validator.MessageType']}</ui:define>
                                        <h:inputText id="messageTypeId" value="#{statisticsManager.params.messageType}" styleClass="form-control labelOnTopForm"/>
                                    </ui:decorate>
                                    <ui:decorate template="/layout/form/_edit.xhtml">
                                        <ui:param name="id" value="hl7VersionNumberId"/>
                                        <ui:define name="label">#{messages['gazelle.hl7.validator.HL7Versionex25']}
                                        </ui:define>
                                        <h:inputText id="hl7VersionNumberId" value="#{statisticsManager.params.hl7VersionNumber}" styleClass="form-control labelOnTopForm"/>
                                    </ui:decorate>
                                </div>
                            </s:div>
                            <s:decorate template="/layout/form/_edit.xhtml">
                                <ui:define name="label">#{messages['gazelle.hl7.validator.LimitToTop10']}</ui:define>
                                <h:selectBooleanCheckbox value="#{statisticsManager.limitToTop10}"/>
                            </s:decorate>
                        </s:div>
                    </ui:decorate>
                    <a4j:commandButton value="#{messages['gazelle.hl7.validator.ComputeStatistics']}"
                                       onclick="#{rich:component('panelLoading')}.show();"
                                       oncomplete="#{rich:component('panelLoading')}.hide();drawAllCharts();"
                                       render="globalform"
                                       styleClass="gzl-btn"/>
                    <a4j:commandButton value="#{messages['gazelle.hl7.validator.ResetCriteria']}"
                                       actionListener="#{statisticsManager.reset()}"
                                       onclick="#{rich:component('panelLoading')}.show();"
                                       oncomplete="#{rich:component('panelLoading')}.hide();drawAllCharts();"
                                       render="globalform"
                                       styleClass="gzl-btn"/>
                </ui:decorate>
                <ui:decorate template="/layout/panels/_panel_title.xhtml">
                    <ui:define name="panel_title">
                        #{messages['gazelle.hl7.validator.ChartsOverview']}
                    </ui:define>
                    <h:outputText
                            value="#{messages['gazelle.hl7.validator.ThisSearchHasReturned']} #{statisticsManager.getTotalNumberOfMessagesForCriteria()} #{messages['gazelle.hl7.validator.ValidationRequests']}"/>
                    <br/>
                    <h:outputText
                            value="#{messages['gazelle.hl7.validator.AmongThoseRequests']}, #{statisticsManager.totalNumberOfProfilesForCriteria} #{messages['gazelle.hl7.validator.DifferentHL7MessageProfilesHaveBeenUsedOutOfThe']} #{statisticsManager.totalNumberOfProfiles} #{messages['gazelle.hl7.validator.AvailableInOurDatabase']}"/>
                    <div class="row">
                        <s:div id="miniBarDiv" styleClass="col-lg-2">
                                <a href="#columnchart1">
                                    <img src="../img/columnchart1.gif"/>
                                </a>
                                <h:outputText value="#{messages['gazelle.hl7.validator.RepartitionPerProfile']}"/>
                        </s:div>
                        <s:div id="miniRepartitionDiv" styleClass="col-lg-2">
                                <a href="#piechart">
                                    <img src="../img/piechart.gif"/>
                                </a>
                                <h:outputText value="#{messages['gazelle.hl7.validator.RepartitionPerResult']}"/>
                        </s:div>
                        <s:div id="miniCallerIpDiv" styleClass="col-lg-2">
                                <a href="#columnchart2">
                                    <img src="../img/columnchart2.gif"/>
                                </a>
                                <h:outputText value="#{messages['gazelle.hl7.validator.RepartitionPerIP']}"/>
                        </s:div>
                        <s:div id="miniTimelineDiv" styleClass="col-lg-2">
                                <a href="#timelinemonth">
                                    <img src="../img/timelinemonth.gif"/>
                                </a>
                                <h:outputText value="#{messages['gazelle.hl7.validator.Timelinemonth']})"/>
                        </s:div>
                        <s:div id="miniTimelineDiv2" styleClass="col-lg-2">
                                <a href="#timelineyear">
                                    <img src="../img/timelineyear.gif"/>
                                </a>
                                <h:outputText value="#{messages['gazelle.hl7.validator.Timelineyear']})"/>
                        </s:div>
                    </div>
                </ui:decorate>
                <br/>
                <ui:decorate template="/layout/panels/_panel_title.xhtml" rendered="#{statisticsManager.selectedReferences != null}">
                    <ui:define name="panel_title">
                        #{messages['gazelle.hl7.validator.SelectedProfiles']}
                    </ui:define>
                    <rich:dataTable id="profilesTable" rows="#{dataScrollerMemory.numberOfResultsPerPage}" value="#{statisticsManager.selectedReferences}"
                                    var="varProfile"
                                    render="ds">
                        <ui:include src="/columns/profileReferences.xhtml">
                            <ui:param name="currentProfile" value="#{varProfile}"/>
                        </ui:include>
                        <f:facet name="footer">
                            <ui:include src="/util/datatableFooter.xhtml">
                                <ui:param name="dataScrollerId" value="ds"/>
                                <ui:param name="dataTableId" value="profilesTable"/>
                            </ui:include>
                        </f:facet>
                    </rich:dataTable>
                </ui:decorate>
                <br/>
                <ui:decorate template="/layout/panels/_panel_title.xhtml">
                    <ui:define name="panel_title">
                        #{messages['gazelle.hl7.validator.NumberOfValidationPerProfiles']}
                    </ui:define>
                    <h:outputText
                            value="#{messages['gazelle.hl7.validator.OnlyThe10MoreUsedProfilesAreDisplayedBelowUntick']}"
                            rendered="#{statisticsManager.limitToTop10}"/>
                    <div class="gzl-never-wrap">
                        <a name="columnchart1"/>
                        <div id="columnDiv" style="width: 900px; height: 500px;"/>
                    </div>
                </ui:decorate>
                <ui:decorate template="/layout/panels/_panel_title.xhtml">
                    <ui:define name="panel_title">
                        #{messages['gazelle.hl7.validator.RepartitionOfValidationOutcomes']}
                    </ui:define>
                    <a name="piechart"/>
                    <div id="repartitionDiv" style="width: 900px; height: 500px;"/>
                </ui:decorate>
                <ui:decorate template="/layout/panels/_panel_title.xhtml">
                    <ui:define name="panel_title">
                        #{messages['gazelle.hl7.validator.RepartitionOfValidationByCallersIP']}
                    </ui:define>
                    <a name="columnchart2"/>
                    <h:outputText
                            value="#{messages['gazelle.hl7.validator.OnlyThe10MoreUsedIPAddressesAreDisplayedBelowUnt']}"
                            rendered="#{statisticsManager.limitToTop10}"/>
                    <div id="callerIpDiv" style="width: 900px; height: 500px;"/>
                </ui:decorate>
                <ui:decorate template="/layout/panels/_panel_title.xhtml">
                    <ui:define name="panel_title">
                        #{messages['gazelle.hl7.validator.TimelineamountOfValidationRequestsPerMonths']})
                    </ui:define>
                    <a name="timelinemonth"/>
                    <div id="timeline_month" style="width: 900px; height: 500px;"/>
                </ui:decorate>
                <ui:decorate template="/layout/panels/_panel_title.xhtml">
                    <ui:define name="panel_title">
                        #{messages['gazelle.hl7.validator.TimelineamountOfValidationRequestsPerYear']})
                    </ui:define>
                    <a name="timelineyear"/>
                    <div id="timeline_year" style="width: 900px; height: 500px;"/>
                </ui:decorate>
                <br/>
            </s:div>
        </h:form>
    </ui:define>
</ui:composition>